#IF 0  ' 

    randomise a list of text in a text file that is CRLF delimited

    Build this file with PBCC50

#ENDIF ' 

    %usemacros = 1

    #include "\pbwin90\include\win32api.inc"    ' <<<<---- change this to your own path

    GLOBAL nrandom_seed as DWORD

' 

FUNCTION PBmain as LONG

    LOCAL lcnt as DWORD
    LOCAL pcnt as DWORD
    LOCAL flen as DWORD

    cmd$ = command$                         ' load the command line

    sfile$ = parse$(cmd$," ",1)             ' input source file
    If exist(sfile$) = 0 Then
      StdOut "Cannot find source file"
      Exit FUNCTION
    End if

    dfile$ = parse$(cmd$," ",2)             ' output destination file
    If dfile$ = "" Then
      StdOut "No target file specified"
      Exit FUNCTION
    End if

    rseed$ = parse$(cmd$," ",3)             ' optional random generator seed number

    Open sfile$ for Binary as #1
      flen = lof(1)
      Get$ #1,flen,src$                     ' read source file into a string
    Close #1

    StdOut sfile$ + " opened at" + str$(flen) + " bytes"

    dim sarr(0) as STRING                   ' dimension an empty string array

    pcnt = tokenise(src$,sarr())            ' tokenise source to array removing blank lines and leading spaces

    If rseed$ <> "" Then
      nrandom_seed = val(rseed$)
    Else
      nrandom_seed = val(left$(strreverse$(ltrim$(str$(GetTickCount))),6))
    End If

  ' ------------------------------------------------------------
  ' shuffle text file a random number of times between 20 and 50
  ' ------------------------------------------------------------

    lcnt = nrandom(30)+20

    StdOut "Shuffling " + sfile$ + str$(lcnt)+" times"

    Do
      shuffle_array(VarPtr(sarr(0)),pcnt)       ' shuffle the string array POINTERS
      ! sub lcnt, 1
    Loop while lcnt <> 0

  ' ------------------------------------------------------------

    shfld$ = join$(sarr(),chr$(13,10))          ' screw them all back together again

    erase sarr()

    Open dfile$ for Output as #1
      Print #1, shfld$
    Close #1

    StdOut dfile$ + " written to disk at"+str$(len(shfld$))+" bytes"

End FUNCTION

' 

FUNCTION exist(fname$) as DWORD
  FUNCTION = Len( Dir$(fname$, 17) ) > 0
END FUNCTION

' 

FUNCTION shuffle_array(ByVal arr as DWORD,ByVal cnt as DWORD) as DWORD

    #REGISTER NONE

    LOCAL lcnt   as DWORD

    ! mov eax, cnt              ' copy cnt to lcnt
    ! mov lcnt, eax

    ! mov esi, arr
    ! mov edi, arr
    ! xor ebx, ebx

  #align 4
  stlp:
    ! push cnt
    ! call nrandom              ' get the random number within "cnt" range 
    ! mov ecx, [esi+ebx*4]      ' get the incremental pointer
    ! mov edx, [edi+eax*4]      ' get the random pointer
    ! mov [esi+ebx*4], edx      ' write random pointer back to incremental location
    ! mov [edi+eax*4], ecx      ' write incremental pointer back to random location
    ! add ebx, 1                ' increment the original pointer
    ! sub lcnt, 1               ' decrement the loop counter
    ! jnz stlp

    ! mov FUNCTION, eax

END FUNCTION

' 

FUNCTION nrandom (ByVal nbase as DWORD) as DWORD

    #REGISTER NONE

    ! mov eax, nrandom_seed

  ' ****************************************
    ! test eax, &H80000000
    ! jz  nxt
    ! add eax, &H7FFFFFFF
  nxt:   
  ' **************************************** 

    ! xor edx, edx
    ! mov ecx, 127773
    ! div ecx
    ! mov ecx, eax
    ! mov eax, 16807
    ! mul edx
    ! mov edx, ecx
    ! mov ecx, eax
    ! mov eax, 2836
    ! mul edx
    ! sub ecx, eax
    ! xor edx, edx
    ! mov eax, ecx
    ! mov nrandom_seed, ecx
    ! div nbase

    ! mov eax, edx
    ! mov FUNCTION, eax

END FUNCTION

' 

FUNCTION tokenise(src$,arr() as STRING) as DWORD

  ' ********************************************************************
  '
  ' DESCRIPTION
  '
  ' Tokenise a text file into a dynamic string array
  '
  ' input arguments are,
  '
  ' 1. a multiline dynamic string delimited with CRLF pair (13 10)
  ' 2. an empty dynamic string array which must be dimensioned first
  '
  ' EXAMPLE : dim MyArray(0) as STRING
  '           lcnt = tokenise(MySrcString$,MyArray())
  '
  ' NOTE : the function left trims lines of text and removes blank lines
  '
  ' ********************************************************************

    #REGISTER NONE

    LOCAL bcnt as DWORD
    LOCAL lcnt as DWORD
    LOCAL pTxt as DWORD
    LOCAL pArr as DWORD
    LOCAL gArr as DWORD

    cpy$ = src$                         ' work on a copy of the source string
    pTxt = StrPtr(cpy$)

    ! mov edi, 1                        ' set counter to 1 in case of no trailing CRLF
    ! mov esi, pTxt
    ! sub esi, 1
  ' ------------------------------------------------
  ' count line feeds to calculate pointer array size
  ' ------------------------------------------------
  lbl1:
    ! add esi, 1
    ! movzx edx, BYTE PTR [esi]
    ! test edx, edx                     ' test for terminator
    ! jz lbl2
    ! cmp edx, 10                       ' test for line feed
    ! jne lbl1
    ! add edi, 1                        ' lf count in EDI
    ! jmp lbl1
  lbl2:
  ' --------------------
  ' multiply result by 4
  ' --------------------
  ''' ! lea edi, [edi*4]            ' for non PIV hardware

    ! add edi, edi                      ' PIV specific
    ! add edi, edi
    ! mov bcnt, edi

  ' --------------------------
  ' allocate the pointer array
  ' --------------------------
    gArr = GlobalAlloc(%GMEM_FIXED or %GMEM_ZEROINIT,bcnt)

    ! mov edi, gArr                     ' copy allocated memory address into EDI
    ! mov esi, pTxt
    ! xor eax, eax                      ' zero arg counter
    ! sub esi, 1
    ! jmp ftrim

  ' ---------------------------------

  #align 4
  terminate:
    ! mov BYTE PTR [esi], 0             ' terminate end of current line

  ftrim:                                ' scan to find next acceptable character
    ! add esi, 1
    ! movzx edx, BYTE PTR [esi]         ' zero extend byte
    ! test edx, edx                     ' test for zero terminator
    ! jz lout
    ! cmp edx, 32
    ! jbe ftrim                         ' scan again for 32 or less

  ' =================
    ! mov [edi], esi                    ' write current location to pointer
    ! add edi, 4                        ' set next pointer location
    ! add eax, 1                        ' increment arg count return value
  ' =================

  ttrim:                                ' scan to find the next CR or LF
    ! add esi, 1
    ! movzx edx, BYTE PTR [esi]         ' zero extend byte
    ! cmp edx, 13
    ! jg ttrim                          ' short loop on normal case

    ! je terminate
    ! cmp edx, 10                       ' extra test for ascii 10
    ! je terminate
    ! test edx, edx
    ! jnz ttrim                         ' loop back if not zero, IE TAB.

  ' ---------------------------------

  lout:
    ! mov lcnt, eax

    redim arr(lcnt) as STRING               ' redimension the array to the required line count
    dim zarr(lcnt) as ASCIIZ PTR at gArr    ' overlay an ASCIIZ array over gArr

    ! mov esi, lcnt
    bcnt = 0                            ' reuse bcnt as the array index
  cpyit:
    arr(bcnt) = @zarr(bcnt)             ' copy zero terminated data to dynamic string array
    ! add bcnt, 1
    ! sub esi, 1
    ! jnz cpyit

    erase zarr()                        ' erase overlayed array
    GlobalFree gArr                     ' free allocated global memory

    FUNCTION = lcnt                     ' return array member count

END FUNCTION

' 
